/* BEGIN: Search */
function getOptionsFromDefaultForm () {
	var form = document.forms['search-form'];
	if (!form) { return {}; }
	var inputField = form['search-input'];
	if (inputField.value.length <= 0) {
		$(inputField).addClass('eAu-error-input');
		return null;
	}
	var searchType = 'all';
	for (var i = 0; i < form['search-type'].length; ++i) {
		if (form['search-type'][i].checked) {
			searchType = form['search-type'][i].value;
			break;
		}
	}
	return {
		mode: form['search-mode'].value,
		type: searchType,
		str:  inputField.value
	};
}
function getOptionsFromDS () {
	var searchOptions = {};
	if (DS.has('search-mode')) {
		searchOptions.mode = DS.get('search-mode');
	}
	if (DS.has('search-type')) {
		searchOptions.type = DS.get('search-type');
	}
	return searchOptions;
}
function executeSearchQuery (options) {
	var defaultOptions = getOptionsFromDefaultForm();
	if (defaultOptions === null) {
		return;
	}
	
	var optionsFromDS = getOptionsFromDS();

	options = _({ mode: 'current', type: 'any', str:  '' })
		.chain()
		.extend(optionsFromDS)
		.extend(defaultOptions)
		.extend(options || {})
		.value();
	
	DS.set('search-type', options.type);
	DS.set('search-string', options.str);
	DS.set('search-mode', options.mode);

	loadingProxy();
}
function getSearchSelect () {
	var mode = DS.get('search-mode');
	var appendixes = head.selectNodes("//appendix-item");
	var ret = {
		first: [
			'<select class="search-mode eAu-input-text" id="search-mode" name="search-mode">',
			'	<option value="current" '+ (mode == 'current' ? 'selected' : '') +'>В текущем модуле</option>',
			use_internal_navigation ? '	<option value="all" '+ (mode == 'all' ? 'selected' : '') +'>Везде</option>' : '',
			(appendixes.length > 0 && use_internal_navigation) ? '	<option value="all-course" '+ (mode == 'all-course' ? 'selected' : '') +'>В основных материалах курса</option>' : '',
			(appendixes.length > 0) ? '	<option value="all-appendixes" '+ (mode == 'all-appendixes' ? 'selected' : '') +'>В дополнительных материалах курса</option>' : '',
			use_internal_navigation ? '	<option value="headers" '+ (mode == 'headers' ? 'selected' : '') +'>В заголовках</option>' : '',
			'</select>'
		]
	};
	ret.first = ret.first.join('');
	ret.third = mode;
	return ret;
}

function getSearchForm () {
	var value = '';
	var checked = '';
	if (DS.has('search-string')) {
		value = DS.get('search-string');
	} else if (DS.has('|lastSearch_searchString')) {
		value = DS.get('|lastSearch_searchString');
	}
	if (DS.get('search-type') != 'any') {
		checked = 'all';
	}
	var searchOptions = getSearchSelect();
	var searchForm = [
		'<h1 class="eAu">Расширенный поиск</h1>',
		'<form onsubmit="executeSearchQuery(); return false;" name="search-form" class="eAu-search-form">',
		'	<table border="0" cellspacing="0" cellpadding="0" width="100%">',
		'		<tr>',
		'			<td valign="middle" width="40%">',
		'				<input value="'+value+'" type="text" id="search-input" class="eAu-input-text eAu-search-input" name="search-input"',
		'					onkeypress="$(this).removeClass(\'eAu-error-input\');"/>',
		'			</td>',
		'			<td width="1">',
		'				<input type="image" src="images/buttons/search.gif" onclick="executeSearchQuery(); return false;" title="Найти" class="eAu-search-form-submit" />',
		'			</td>',
		'			<td></td>',
		'		</tr>',
		'	</table>',
		'	<h2 class="eAu">Параметры поиска</h2>',
		'	<div><input type="radio" name="search-type" value="any" id="search-type-0" ' + (checked == 'all' ? '' : ' checked="checked" ') +' /> <label for="search-type-0">Найти отдельные слова</label></div>',
		'	<div><input type="radio" name="search-type" value="all" id="search-type-1" ' + (checked == 'all' ? ' checked="checked" ' : '') +' /> <label for="search-type-1">Найти фразу целиком</label></div>',
		'	<table border="0" cellpadding="0" cellspacing="0" style="margin-top: 6px;"><tr>',
		'		<td><div>Где искать:&nbsp;</div></td>',
		'		<td>'+ searchOptions.first+'</td>',
		'	</tr></table>',
		'</form>'
	].join('');

	return '<div class="eAu-search">' + searchForm + '<div class="eAu-search-results" id="eAu-search-results"></div></div>';
}
function getMatchesFromPackedString (str) {
	var matchIds = str.split(/\s+/);
	var matches = [];
	for (var i = 0; i < matchIds.length; ++i) {
		var match = _Xml.$(head, matchIds[i]);
		if (match) {
			matches.push(match);
		}
	}
	return matches;
}
function packMatchesIntoString (matches) {
	var str = [];
	for (var i = 0; i < matches.length; ++i) {
		str.push(_Xml.id(matches[i]));
	}
	return str.join(' ');
}
function getSearchResults () {
	$window.one('eAu:content:afterchange', function () {
		if (DS.get('search-string')) {
			$('#eAu-search-results').html('<div class="eAu-content-dotted-line"></div><h1 class="eAu">Результаты поиска</h1><div id="eAu-search-results-list"></div>');
			var searchOptions = _.extend({
				mode: 'all',
				type: 'any'
			}, getOptionsFromDS());
			showContentLoader($('#eAu-search-results-list'));
			_.delay(function() {
				var matches = contextSearch(DS.get('search-string'), searchOptions);
				printSearchResults(matches, 'eAu-search-results-list');
			}, 10);
		} else if (DS.has('|lastSearch_searchString') && DS.has('|lastSearch_searchResults')) {
			$('#eAu-search-results')
				.html('<div class="eAu-content-dotted-line"></div><h1 class="eAu">Результаты поиска</h1><div id="eAu-search-results-list"></div>');
			DS.set('search-string', DS.get('|lastSearch_searchString'));
			printSearchResults(getMatchesFromPackedString(DS.get('|lastSearch_searchResults')), 'eAu-search-results-list');
		}
	});
	
	text_transform(getSearchForm(), 'cont');
}
function printSearchResults (matches, outputHtmlId) {
	var ac = arguments.callee,
	    node = document.getElementById(outputHtmlId),
	    output = [];
	
	if (!ac.template) {
		ac.template = _.template([
			'<li class="eAu-search-result-item">',
			'	<h2 class="eAu"><a href="index.htm" db-id="<%= id %>" onclick="return false;" target="_top"><%= title %></a></h2>',
			'	<div class="eAu-search-result-item"><%= text %></div>',
			'</li>'
		].join(''));
		ac.rootTemplate = _.template('<ul class="eAu-search-result-items"><% _.each(items, function (item) { %><%= item %><% }); %></ul>');
	}
	
	output = _.map(matches, function (match) {
		var text;
		if (use_internal_navigation && /^(subject|reference)$/.test(_Xml.name(match))) {
			match = _Xml.parentOrSelf(match, 'lesson unit');
		}
		if (!match) { return null; }
		text = eAu.String.trim(eAu.String.stripTags(_Xml.text(match)));
		return ac.template({
			id: _Xml.id(match),
			title: _Xml.title(match),
			text: text.length > 300 ? text.substr(0, 300) + '…' : text
		});
	});
	
	if (output.length == 0) {
		output = '<div class="eAu-search-results"><div class="eAu-nothing-found">По вашему запросу ничего не найдено.</div></div>';
	} else {
		output = ac.rootTemplate({ items: output });
	}

	DS.set('|lastSearch_searchString', DS.get('search-string'));
	DS.set('|lastSearch_searchResults', packMatchesIntoString(matches));
	if (DS.get('|lastSearch_searchString')) {
		DS.set('search-string', DS.get('|lastSearch_searchString'));
	}
	if (DS.get('search-string')) {
		DS.set('search-highlight', DS.get('search-string'));
	}
	$(node).html(text_transform(output));
	$window.trigger('eAu:search:results:shown', {node: $('#cont')});
	if (DS.get('search-string')) {
		DS.set('search-highlight', DS.get('search-string'));
	}
}
function contextSearch (searchString, searchOptions) {
	if (!searchString) { return; }
	searchString = Sarissa.escape(searchString);
	var context = searchOptions.mode == 'current' && DS.has('id') ? _Xml.$(head, DS.get('id')) : null,
	    nodesList = [],
	    searchNodes = [];

	switch (searchOptions.mode) {
		case 'headers':
			nodesList = head.selectNodes([
				"//lesson",
				"//unit",
				"//studiedproblem",
				"//test",
				"//intro"
			].join('|'));
			break;
		case 'current':
			nodesList = (context || head).selectNodes([
				"descendant-or-self::studiedproblem[not(@group-text-nodes = 'false')]",
				"descendant-or-self::text[../@group-text-nodes = 'false']",
				"descendant-or-self::subject",
				"descendant-or-self::intro"
			].join('|'));
			break;
		case 'all-appendixes':
			nodesList = head.selectNodes([
				"appendixes/appendix-item/descendant::studiedproblem",
				"appendixes/appendix-item/descendant::subject", // if any :)
				"appendixes/appendix-item/intro"
			].join('|'));
			break;
		case 'all-course':
			nodesList = head.selectNodes([
				"study-modules/descendant::studiedproblem[not(@group-text-nodes = 'false')]",
				"study-modules/descendant::text[../@group-text-nodes = 'false']",
				"study-modules/descendant::subject",
				"study-modules/intro"
			].join('|'));
			break;
		default:
		case 'all':
			nodesList = head.selectNodes([
				"//studiedproblem[not(@group-text-nodes = 'false')]",
				"//text[../@group-text-nodes = 'false']",
				"//subject",
				"//intro"
			].join('|'));
			break;
	}
	for (var i = 0, length = nodesList.length; i < length; ++i) {
		if (_Xml.isVisible(nodesList[i], true) || _Xml.parentOrSelf(nodesList[i], 'appendix-item')) {
			searchNodes.push(nodesList[i]);
			_Xml.fetch(nodesList[i], true);
		}
	}
	var searchTerms = eAu.String.RegExpEscape(eAu.String.trim(searchString)).split(/\s+/),
	    chars       = "[\\s\\u00A0\\\\/(){}\\[\\]\"'.,:?!;%#@№$\\^\\-&*|~…¡¿§–—`´«»‘’‚‛“”„‹›]",
	    startRegExp = "(^|" + chars + ")",
	    endRegExp   = "("+ chars +"|$)",
		flags       = "im";
	
	var regExps = (searchOptions.type == 'all')
		? [ new RegExp(startRegExp + searchTerms.join('(\\s|\\u00A0)+') + endRegExp, flags) ]
		: _.map(searchTerms, function (item) { return new RegExp(startRegExp + item + endRegExp, flags); });
	
	var getSearchTextFunction = (searchOptions.mode == 'headers')
		? function (node) { return eAu.String.stripTags( _Xml.title(node) ).replace(/&nbsp;/g, ' ') }
		: function (node) { return eAu.String.stripTags( _Xml.title(node) + ' ' + _Xml.text(node) ).replace(/&nbsp;/g, ' '); };
	
	return _.filter(searchNodes, function (node) {
		var nodeText = getSearchTextFunction(node);
		return !_.isUndefined(_.detect(regExps, function (regExp) {
			return regExp.test(nodeText);
		}));
	});
}
function loadSearchPageEx() {
	DS.unset('glossary');
	DS.unset('appendix-id');
	DS.set('search', '');
	loadingProxy();
}
/* END: Search */
