function toggleElementVisibility(element) {
	element = $(element);
	var ElementLeft = parseInt(element.css('left'), 10);
	var isElementVisible = isNaN(ElementLeft) || ElementLeft >= -3333;

	if (isElementVisible) {
		hideElement(element);
	} else {
		showElement(element);
	}

	return !isElementVisible;
}
function hideElement(element) {
	element = $(element);
	var ElementLeft = parseInt(element.css('left'), 10);
	var isElementVisible = isNaN(ElementLeft) || ElementLeft >= -3333;
	if (!isElementVisible) {
		return;
	}

	element.css({
		'left': -30000,
		'right': 'auto'
	});
}
function showElement(element) {
	element = $(element);
	var ElementLeft = parseInt(element.css('left'), 10);
	var isElementVisible = isNaN(ElementLeft) || ElementLeft >= -3333;
	if (isElementVisible) {
		return;
	}

	element.css({
		'left': -3000,
		'right': 'auto'
	});
}
function isElementVisible(element) {
	var ElementCssLeft =   parseInt(element.css('left'), 10);
	return isNaN(ElementCssLeft) || ElementCssLeft >= -3333;
}
var Resizers = (function() {
	var _Resizers = {}; // Список всех функций, контролирующих размер
	var _ResizersOrder = [];
	var _ElementsCache = {};

	$(window).bind('unload', function() {
		for (var item in _ElementsCache) {
			delete _ElementsCache[item];
		}
	});

	var cache = {
		get: function(id) {
			_ElementsCache[id] = _ElementsCache[id]
				? _ElementsCache[id]
				: $(id);

			return _ElementsCache[id];
		}
	}
	
	return {
		resize: function(event, itemId) {
			var viewport = {
				height: $(window).height(),
				width: $(window).width()
			}

			if (itemId && _Resizers[itemId]) {
				_Resizers[itemId](event, cache, viewport);
				return;
			}
			for (var i = 0, length = _ResizersOrder.length; i < length; ++i) {
				_Resizers[_ResizersOrder[i]](event, cache, viewport);
			}
		},
		add: function(itemId, resizeFunction, reregister) {
			if (!_.isFunction( resizeFunction )) {
				throw "Invalid resize handler";
			}
			if (!itemId || typeof itemId != 'string') {
				throw "Invalid handler id";
			}
			var hasItem = !!_Resizers[itemId];
			if (_Resizers[itemId] && !reregister) { return false; }
			_Resizers[itemId] = resizeFunction;
			if (!hasItem) {
				_ResizersOrder.push(itemId);
			}
			return true;
		}
	};
})();

Resizers.add('breadedcrumbs', function(event, ec, vp) {
	var menu          = ec.get('#menu');
	var layoutHeader  = ec.get('#layout-header');
	var breadedCrumbs = ec.get('#breaded-crumbs');
	
	var minContentWidth = 424;
	
	var isMenuPositionStatic = $(document.body)
		.is('.menu-layout-static');
	
	var LayoutHeaderHeight = layoutHeader.is(':visible')
		? layoutHeader.height()
		: 0;
	var menuWidth = isMenuPositionStatic
		? menu.width()
		: 0;
	var BreadedCrumbsWidth = vp.width - menuWidth;
	BreadedCrumbsWidth = BreadedCrumbsWidth >= minContentWidth
		? BreadedCrumbsWidth
		: minContentWidth;
	
	var BCLeft = menuWidth;
	var BCTop  = LayoutHeaderHeight;
	
	var BCCss = {};
	if (parseInt(breadedCrumbs.css('width'), 10) != BreadedCrumbsWidth) {
		BCCss.width = BreadedCrumbsWidth;
	}
	if (parseInt(breadedCrumbs.css('top'), 10) != BCTop) {
		BCCss.top = BCTop;
	}
	if (parseInt(breadedCrumbs.css('left'), 10) != BCLeft) {
		BCCss.left = BCLeft;
	}
	
	breadedCrumbs.css(BCCss);
});

Resizers.add('content', function(event, ec, vp) {
	var content       = ec.get('#content');
	var menu          = ec.get('#menu');
	var layoutBody    = ec.get('#layout-body');
	var layoutHeader  = ec.get('#layout-header');
	var layoutBottom  = ec.get('#layout-bottom');
	var breadedCrumbs = ec.get('#breaded-crumbs');

	var minContentHeight = 55;
	var minContentWidth = 424; // Ширина 2-х панелей кнопок справа и слева по 105
	                           // + кнопки навигации 2 * 70
	                           // + padding у тулбара 2 * 20
	                           // + 2 * 17 для 2-х элементов слайдера (минимум)

	var isMenuPositionStatic = $(document.body)
		.is('.menu-layout-static');

	var LayoutHeaderHeight = layoutHeader.is(':visible')
		? layoutHeader.height()
		: 0;
	var LayoutBottomHeight = layoutBottom.height();
	var BreadedCrumbsHeight = breadedCrumbs.is(':visible')
		? breadedCrumbs.height()
		: 0;
	var menuWidth = isMenuPositionStatic
		? menu.width()
		: 0;

	var ContentWidth = vp.width - menuWidth;
	var ContentHeight = vp.height
		- LayoutHeaderHeight
		- LayoutBottomHeight
		- BreadedCrumbsHeight;
	ContentHeight = ContentHeight >= minContentHeight
		? ContentHeight
		: minContentHeight;
	ContentWidth = ContentWidth >= minContentWidth
		? ContentWidth
		: minContentWidth;

	var ContentCss = {};
	if (parseInt(content.css('width'), 10) != ContentWidth) {
		ContentCss.width = ContentWidth;
	}
	if (parseInt(content.css('height'), 10) != ContentHeight) {
		ContentCss.height = ContentHeight;
	}

	var LayoutBodyTop = LayoutHeaderHeight + BreadedCrumbsHeight;
	var LayoutBodyLeft = menuWidth;
	var LayoutBodyCss = {};
	if (parseInt(layoutBody.css('top'), 10) != LayoutBodyTop) {
		LayoutBodyCss.top = LayoutBodyTop;
	}
	if (parseInt(layoutBody.css('left'), 10) != LayoutBodyLeft) {
		LayoutBodyCss.left = LayoutBodyLeft;
	}

	content
		.css(ContentCss);
	layoutBody
		.css(LayoutBodyCss);
});
Resizers.add('bottom', function(event, ec, vp) {
	var content      = ec.get('#content');
	var layoutBottom = ec.get('#layout-bottom');

	var isMenuPositionStatic = $(document.body)
		.is('.menu-layout-static');

	var ContentWidth             = content.width();
	var CurrentLayoutBottomWidth = layoutBottom.width();

	var LayoutBottomCss = {};
	if (CurrentLayoutBottomWidth != ContentWidth && ContentWidth > 0) {
		LayoutBottomCss.width = ContentWidth;
	}

	layoutBottom.css(LayoutBottomCss);
});
Resizers.add('popups', function(event, ec, vp) {
	resizePopup(ec.get('#menu'), ec, vp, { hoffset: 26 });
	resizePopup(ec.get('#search'), ec, vp, { hoffset: 100 });
	resizePopup(ec.get('#map'), ec, vp, { hoffset: 174 });
});
function resizePopup(element, ec, vp, options) {
	options = _.extend({
		snapTo: 'bottom left',
		hoffset: 26,
		vstemoffset: 0,
		voffset: 5
	}, options || {});

	if (!isElementVisible(element)) {
		return;
	}
	var elementId  = element.attr('id');
	var stemHeight = element.find('> .stem').length ? element.find('> .stem').outerHeight() : 0;
	var offset     = options.vstemoffset;
	var vSnap = ((options.snapTo || '').split(/\s+/)[0]) || 'bottom';
	var hSnap = ((options.snapTo || '').split(/\s+/)[1]) || 'left';

	var elementOverflow = ec.get('#'+ elementId +'-overflow');
	var elementContent  = ec.get('#'+ elementId +'-content');

	elementOverflow.css('overflow', 'hidden');

	// BEGIN: Root layout dimensions
	var layoutHeaderHeight = ec.get('#layout-header').is(':visible')
		? ec.get('#layout-header').height()
		: 0;
	var breadedCrumbsHeight = ec.get('#breaded-crumbs').is(':visible')
		? ec.get('#breaded-crumbs').height()
		: 0;
	var contentHeight = ec.get('#content').height();
	var layoutBottomHeight  = ec.get('#layout-bottom').is(':visible')
		? ec.get('#layout-bottom').height()
		: 0;
	// END: Root layout dimensions

	// BEGIN: POPUP Dimensions
	var elementWidth = element.width();
	
	var elementHeaderHeight = ec.get('#'+ elementId +'-header').is(':visible')
		? ec.get('#'+ elementId +'-header').outerHeight()
		: 0;
	var elementContentHeight = elementContent.outerHeight(true);
	var elementContentPaddings = elementContentHeight - elementContent.height();
	var firstWrapperPaddings = element.find('> .first-wrapper').outerHeight() - element.find('> .first-wrapper').height();
	var secondWrapperMargins = element.find('> .first-wrapper > .second-wrapper').outerHeight(true) - element.find('> .first-wrapper > .second-wrapper').height();
	var elementHeight = contentHeight
		- elementHeaderHeight
		- firstWrapperPaddings
		- secondWrapperMargins
		- stemHeight
		- (options.vstemoffset > 0 ? options.vstemoffset : 0)
		- (options.voffset > 0 ? options.voffset : 0);
	// END: POPUP Dimensions

	// BEGIN: Dimension corrections
	elementHeight = elementHeight > elementContentHeight
		? elementContentHeight
		: elementHeight;
	elementHeight = elementHeight > 0 ? elementHeight : 0;
	// END: Dimension corrections

	var elementLeft = 0;
	if (hSnap == 'right') {
		elementLeft = vp.width - elementWidth - options.hoffset;
	} else if (hSnap == 'left') {
		elementLeft = options.hoffset;
	}
	// END: POPUP Position

	// BEGIN: calculation diff
	var elementCss = {};
	var elementOverflowCss = {};

	if (element.position().left != elementLeft) {
		elementCss.left = elementLeft;
	}
	if (elementOverflow.height() != elementHeight) {
		elementOverflowCss.height = elementHeight;
	}
	// END: calculation diff

	elementOverflow.css('overflow', 'auto');
	element.css(elementCss);
	elementOverflow.css(elementOverflowCss);
	if (parseInt(element.css('bottom'), 10) == layoutBottomHeight) {
		$('#button-' + element.attr('id')).css({
			top: -element.outerHeight() - 1
		});
	}
}

$(function () {
	//$(".cute-popup").bgiframe({opacity: true});
});

$(function() {
	$('.toolbar .button')
		.addClass('button-hidden');
});
